﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using StructureMap;
using MedievalExample.Repository.Interface;
using MedievalExample.DB;

namespace MedievalExample.Business
{
    public static class DragonManager
    {
        private static IRepository<Dragon> _repository
        {
            get
            {
                return ObjectFactory.GetInstance<IRepository<Dragon>>();
            }
        }

        public static List<Dragon> GetAll()
        {
            List<Dragon> dragonList = new List<Dragon>();

            // Fetch all Dragon entities from the repository.
            dragonList = _repository.GetAll().ToList();

            return dragonList;
        }

        public static Dragon CreateDragon(Weapon weapon)
        {
            Random r = new Random((int)DateTime.Now.Ticks);

            // Create a new dragon.
            Dragon dragon = new Dragon();
            dragon.Name = GenerateName();
            dragon.Age = r.Next(100, 500);

            // Set the dragon's weapon.
            dragon.Weapon = weapon;

            // Save the dragon.
            _repository.Add(dragon);

            return dragon;
        }

        private static string GenerateName()
        {
            string name = "";

            string[] front = 
            {
                "Fang",
                "Rubon",
                "Slar",
                "Xen",
                "Dread"
            };

            string[] back =
            {
                "icus",
                "ozore",
                "anar",
                "edren"
            };

            Random r = new Random((int)DateTime.Now.Ticks);

            int i = r.Next(front.Length);
            name = front[i];

            i = r.Next(back.Length);
            name += back[i];

            return name;
        }
    }
}
