﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using StructureMap;
using MedievalExample.Repository.Interface;
using MedievalExample.Repository.Base;
using MedievalExample.DB;

namespace MedievalExample.Business
{
    public static class GeneralManager
    {
        public static void Initialize()
        {
            // Hook up the interception
            ObjectFactory.Initialize(
                x =>
                {
                    x.ForRequestedType<IUnitOfWorkFactory>().TheDefaultIsConcreteType<EFUnitOfWorkFactory>();
                    x.ForRequestedType(typeof(IRepository<>)).TheDefaultIsConcreteType(typeof(EFRepository<>));
                }
            );

            // We tell the concrete factory what EF model we want to use
            EFUnitOfWorkFactory.SetObjectContext(() => new MedievalEntities());
        }

        public static void Commit()
        {
            UnitOfWork.Commit();
        }

        public static void Dispose()
        {
            UnitOfWork.Current.Dispose();
        }
    }
}
