﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using StructureMap;
using MedievalExample.Repository.Interface;
using MedievalExample.DB;

namespace MedievalExample.Business
{
    public static class WeaponManager
    {
        private static IRepository<Weapon> _repository
        {
            get
            {
                return ObjectFactory.GetInstance<IRepository<Weapon>>();
            }
        }

        public static Weapon CreateWeapon()
        {
            // Create a new weapon.
            Weapon weapon = new Weapon();
            weapon.Name = "Fire";
            weapon.Damage = 100;

            // Set the weapon's weapon type.
            weapon.WeaponType = WeaponTypeManager.GetByName("Breath");

            // Save the weapon.
            _repository.Add(weapon);

            return weapon;
        }
    }
}
