﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using MedievalExample.Business;
using MedievalExample.DB;

namespace MedievalExample
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                BindGrid();
            }
        }

        private void BindGrid()
        {
            // Call the repository manager to query all Dragon entities.
            lstDragons.DataSource = DragonManager.GetAll();
            lstDragons.DataBind();
        }

        protected void btnAdd_Click(object sender, EventArgs e)
        {
            // Create a weapon. No SQL is executed yet.
            Weapon weapon = WeaponManager.CreateWeapon();

            // Create a dragon with the weapon. No SQL is executed yet.
            DragonManager.CreateDragon(weapon);

            // The complete unit of work is executed and changes committed to the database.
            GeneralManager.Commit();

            // Refresh the grid.
            BindGrid();
        }
    }
}
